<?php
/**************************************************
  Coppermine 1.5.x Plugin - photocols
  *************************************************
  Copyright (c) 2014 Mykee (www.acegem.hu)
  *************************************************
  This plugin based on photocols gallery script.
  More parameters, license visit developer's website: https://github.com/2CodersTeam/jquery.photocols
  ************************************************
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/branches/cpg1.5.x/plugins/photocols/codebase.php $
  $Revision: 6994 $
  $LastChangedBy: mykee $
  $Date: 2014-07-11 14:05:10 +0100 (Fri, 11 July 2014) $
  **************************************************/
  
if (!defined('IN_COPPERMINE')) { 
    die('Not in Coppermine...');
}


// Add plugin_install action
$thisplugin->add_action('plugin_install','photocols_install');
// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','photocols_uninstall');

function photocols_noindex () {
  global $superCage;
   if ($superCage->get->keyExists('cat') or $superCage->get->keyExists('file')) {
      return "1";
    } else {
      return "0";    
    }
}
$photocols_noindex = photocols_noindex();


if ($photocols_noindex == "0"){
// Add filter for page head
$thisplugin->add_action('page_start','photocols_head');
// Add search display action
$thisplugin->add_filter('plugin_block','photocols_mainpage');
//Add plus styles for metas
$thisplugin->add_filter('page_meta','photocols_header_addons');
//Add script to footer
$thisplugin->add_filter('gallery_footer','photocols_footer_addons');
}


// include some stuff in page header
function photocols_head()
{        
    global $PHOTOCOLSSET, $CONFIG, $CPG_PHP_SELF, $JS;
    require ('./plugins/photocols/include/load_photocolsset.php');
    // only insert stuff if we're on album list page
    $photocols_pages_array = array('index.php');
   if (in_array($CPG_PHP_SELF, $photocols_pages_array) == TRUE)
    {
       if($PHOTOCOLSSET['photocols_jquery'] == 1) {
         //Replace old JQuery to newer
        if (in_array('js/jquery-1.3.2.js', $JS['includes']) == TRUE) {
            $key = array_search('js/jquery-1.3.2.js', $JS['includes']);
            unset($JS['includes'][$key]);
            $key = array_search('js/jquery.greybox.js', $JS['includes']);
            unset($JS['includes'][$key]);
            $key = array_search('js/jquery.elastic.js', $JS['includes']);
            unset($JS['includes'][$key]);
            array_unshift($JS['includes'][] = "plugins/photocols/js/jquery-1.11.1.min.js");
            array_unshift($JS['includes'][] = "plugins/photocols/js/jquery-migrate-1.2.1.min.js");
            array_unshift($JS['includes'][] = "js/jquery.greybox.js");
            array_unshift($JS['includes'][] = "js/jquery.elastic.js");
        } else {
          //No replace just insert
          $JS['includes'][] = "plugins/photocols/js/jquery-1.11.1.min.js";
          $JS['includes'][] = "plugins/photocols/js/jquery-migrate-1.2.1.min.js";
        }
       }
    } 
}


/* Header style addons */
function photocols_header_addons($html)
{ 
    global $thisplugin, $PHOTOCOLSSET,$CONFIG;
    
    $classname = $PHOTOCOLSSET['photocols_ulclass'];
    $cssblock = '';

    $cssblock = '<link rel="stylesheet" type="text/css" href="plugins/photocols/css/main.css" media="all" />';

  
if($PHOTOCOLSSET['photocols_compatcode'] == 1) {         
$cssblock = $cssblock."\n". <<< EOT
<!--[if lt IE 9]><script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script><![endif]-->
EOT;
} 
    return $cssblock.$html;
}
 
 
/* Plugin main */
function photocols_mainpage($matches)
{
 global $CONFIG,$lang_plugin_photocols,$FORBIDDEN_SET,$PHOTOCOLSSET,$lang_meta_album_names,$lang_common,$META_ALBUM_SET, $CPG_PHP_SELF,$matches,$html;

require ('./plugins/photocols/include/init.inc.php');
require ('./plugins/photocols/include/load_photocolsset.php');

 $photocols_pages_array = array('index.php');
 if (in_array($CPG_PHP_SELF, $photocols_pages_array) == TRUE)
 {
  if($matches[1] != 'photocols') {
          return $matches;
  }
  $plugparam = $matches[2];
  $classname = $PHOTOCOLSSET['photocols_ulclass'];
  
  // maximum pics to show
  if ($plugparam >= 10){
  $photocolslimit = $plugparam;
  } else {
  $photocolslimit=$PHOTOCOLSSET['photocols_numberofpics'];
  }
  
  echo "\n"."<div class=\"".$classname."\">"."\n"."<!-- photocols Start -->"."\n";
        
    if ($PHOTOCOLSSET['photocols_header'] == 1){
        $photocols_icon = array( 'topn' => 'most_viewed', 'lastup' => 'last_uploads', 'toprated' => 'top_rated', 'random' => 'random');
        
        if ($plugparam == 1){
        $PHOTOCOLSSET['photocols_album'] = 'toprated';
        } else if ($plugparam == 2){
        $PHOTOCOLSSET['photocols_album'] = 'topn';
        } else if ($plugparam == 3){
        $PHOTOCOLSSET['photocols_album'] = 'lastup';
        } else if ($plugparam > 3 and $plugparam < 10){
        $PHOTOCOLSSET['photocols_album'] = 'random';
        }
        
        starttable("100%", cpg_fetch_icon($photocols_icon[$PHOTOCOLSSET['photocols_album']],0,$lang_meta_album_names[$PHOTOCOLSSET['photocols_album']]).$lang_meta_album_names[$PHOTOCOLSSET['photocols_album']]." (".$photocolslimit." ".$lang_plugin_photocols['pictures'].")");
endtable();
    }
?>
<div id="photocols"></div>
</div>
<!-- photocols End -->
<?php


 } 
}

// Install
function photocols_install()
{
                global $CONFIG, $thisplugin;
                require 'include/sql_parse.php';

                // create table
                $db_schema = $thisplugin->fullpath . '/schema.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');

                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
                
                // insert default values
                $db_schema = $thisplugin->fullpath . '/basic.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');
              
                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
           return true;
}


// Unnstall and drop settings table
function photocols_uninstall()
{
        global $CONFIG;
        cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}plugin_photocols");
        return true;
}


// Add script to footer
function photocols_footer_addons($html) {

 global $CONFIG,$RESTRICTEDWHERE,$lang_plugin_photocols,$FORBIDDEN_SET,$PHOTOCOLSSET,$lang_meta_album_names,$lang_common,$META_ALBUM_SET,$CPG_PHP_SELF,$matches;


if (file_exists("./plugins/photocols/lang/{$CONFIG['lang']}.php")) {
  require "./plugins/photocols/lang/{$CONFIG['lang']}.php";
} else {require "./plugins/photocols/lang/english.php";}

$photocols_pages_array = array('index.php');
 if (in_array($CPG_PHP_SELF, $photocols_pages_array) == TRUE)
 { 
  get_meta_album_set();
        
  $footblock='';
  $plugparam = $matches[2];
  $classname = $PHOTOCOLSSET['photocols_ulclass'];
  
  // maximum pics to show
  if ($plugparam >= 10){
  $photocolslimit = $plugparam;
  } else {
  $photocolslimit=$PHOTOCOLSSET['photocols_numberofpics'];
  }
  
// request of your database
  $photocols_pics='';
   
   if ($PHOTOCOLSSET['photocols_oriental'] == 1) {
    $orifilter = " AND pwidth > pheight ";
   } else if ($PHOTOCOLSSET['photocols_oriental'] == 2) {
    $orifilter = " AND pwidth < pheight ";
   } else {
    $orifilter = "";
   }
   
   
   if ($plugparam != 0) {
   
     // request string for meta album toprated
        if ($plugparam == 1) {
          $photocols_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' AND r.votes >= '{$CONFIG['min_votes_for_rating']}' $META_ALBUM_SET ORDER BY pic_rating DESC, r.votes DESC, pid DESC LIMIT $photocolslimit";
        }
        // request string for meta album most viewed
        else if ($plugparam == 2) {
          $photocols_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' AND hits > 0 $META_ALBUM_SET ORDER BY hits DESC, filename LIMIT $photocolslimit";  
        }
        // request string for meta album last uploads
        else if ($plugparam == 3) {
          $photocols_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' $META_ALBUM_SET ORDER BY pid DESC LIMIT $photocolslimit";  
        }
        // request string for meta album random pics
        else
        {
        $photocols_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' $META_ALBUM_SET ORDER BY RAND() LIMIT $photocolslimit";
        }
   
   }  else {
                                
        // request string for meta album toprated
        if ($PHOTOCOLSSET['photocols_album'] == "toprated") {
          $photocols_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' AND r.votes >= '{$CONFIG['min_votes_for_rating']}' $META_ALBUM_SET ORDER BY pic_rating DESC, r.votes DESC, pid DESC LIMIT $photocolslimit";
        }
        // request string for meta album most viewed
        else if ($PHOTOCOLSSET['photocols_album'] == "topn") {
          $photocols_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' AND hits > 0 $META_ALBUM_SET ORDER BY hits DESC, filename LIMIT $photocolslimit";  
        }
        // request string for meta album last uploads
        else if ($PHOTOCOLSSET['photocols_album'] == "lastup") {
          $photocols_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' $META_ALBUM_SET ORDER BY pid DESC LIMIT $photocolslimit";  
        }
        // request string for meta album random pics
        else
        {
        $photocols_query = "SELECT * FROM {$CONFIG['TABLE_PICTURES']} AS r LEFT JOIN {$CONFIG['TABLE_ALBUMS']} ON  {$CONFIG['TABLE_ALBUMS']}.aid = r.aid $RESTRICTEDWHERE AND filename like '%.jpg'$orifilter AND approved = 'YES' AND filename not like 'youtube_%' $META_ALBUM_SET ORDER BY RAND() LIMIT $photocolslimit";
        }
     }   

  // For reading result
  $photocols_row = array();
  // Index of tab
  $i=0;
  // max height : will be 75px or 100px
  $bgcolor = $PHOTOCOLSSET['photocols_bgcolor'];
  $phwidth = $PHOTOCOLSSET['photocols_phwidth'];
  $phheight = $PHOTOCOLSSET['photocols_phheight'];
  $max_height = $PHOTOCOLSSET['photocols_height'];
  $max_width = $PHOTOCOLSSET['photocols_width'];
  $gap = $PHOTOCOLSSET['photocols_gap'];
  $opacity = $PHOTOCOLSSET['photocols_opacity'];
  $titlesize = $PHOTOCOLSSET['photocols_title'];
  $subsize = $PHOTOCOLSSET['photocols_subtitle'];
  $overlay = $PHOTOCOLSSET['photocols_overlay'];
  $allrow = $PHOTOCOLSSET['photocols_allrow'];
  $desclength = $PHOTOCOLSSET['photocols_wordcut'];
  
  if ($PHOTOCOLSSET['photocols_hover'] == 1) {
   $hover = "true";
  } else {
   $hover = "false";
  }
  
  // For each pic.....building javascript in php
  $photocols_minpics = 10;
  
  // result of request
  $photocols_result = cpg_db_query($photocols_query);


  while($photocols_row = mysql_fetch_array($photocols_result)){
  // reading pid of pic  
  $photocols_key=$photocols_row['pid'];
  $album_title= $photocols_row['title'];
  $album_id = $photocols_row['aid'];
  $photocols_picdesc = $photocols_row['caption'];
  $photocols_picdesc = preg_replace('/^\s+|\n|\r|\s+$/m', '', $photocols_picdesc);
  
    if ($photocols_picdesc != "" && strlen($photocols_picdesc) > $desclength){
    $photocols_picdesc = $photocols_picdesc." ";
    $photocols_picdesc = substr($photocols_picdesc,0,$desclength);
    $photocols_picdesc = substr($photocols_picdesc,0,strrpos($photocols_picdesc,' '));
    $photocols_picdesc = $photocols_picdesc."{$lang_plugin_photocols['photocols_continue']}";
    }
      
    // path of pic
    $photocols_fullfile=get_pic_url($photocols_row, 'fullsize');
    
   if ($PHOTOCOLSSET['photocols_thumb'] == 2) { 
    $photocols_imgfile=get_pic_url($photocols_row, 'normal');
    } else if ($PHOTOCOLSSET['photocols_thumb'] == 0) {
    $photocols_imgfile=$photocols_fullfile;
    } else {
    $photocols_imgfile=get_pic_url($photocols_row, 'thumb');
    }

    list($width, $height) = getimagesize(urldecode($photocols_imgfile));
    
    if ($width == "" || $height =="" ){
        $width = $photocols_row['pwidth'];
        $height = $photocols_row['pheight'];
      }
      
  if ($PHOTOCOLSSET['photocols_thumb'] == 1) {
      if ($width < $CONFIG['thumb_width'] || $height < $CONFIG['thumb_height']){
        $width = $width*1.5;
        $height = $height*1.5;
      }
  } else {
      if ($width > $max_width || $height > $max_width){
      $relat= $width/$max_width; 
      $width = $width/$relat;
      $height = $height/$relat;
      }
  }
    
    if ($photocols_imgfile == "images/thumbs/thumb_nopic.png") $photocols_imgfile="";
    $photocols_pictitle = $photocols_row['14'];
    $photocols_pictitle = preg_replace('/^\s+|\n|\r|\s+$/m', '', $photocols_pictitle);   

    // link of pic
    if ($photocols_imgfile !="") {
    $photocols_lien="{'title': '".$photocols_pictitle."', 'subtitle': '".$photocols_picdesc."','url' :'displayimage.php?album=".$album_id."&pid=".$photocols_key."#top_display_media', 'img':'".$photocols_imgfile."'},"."\n";
    } else {
    $photocols_lien= "";
    }
    
    // building pictures
    $photocols_pics .= $photocols_lien;

   }
    
  // free memory
  mysql_free_result($photocols_result);
    $footblock .= <<< EOT
<script src="plugins/photocols/js/jquery.photocols.min.js" type="text/javascript"></script>
<script type="text/javascript">
var pcoldata = [
{$photocols_pics}
];
jQuery('#photocols').photocols({
    bgcolor: '{$bgcolor}',
    width: '{$phwidth}',
    colswidth : {$max_width},
    itemheight: {$max_height},
    height : {$phheight},
    gap: {$gap},
    opacity: {$opacity},
    titleSize: {$titlesize},
    subtitleSize: {$subsize},         
    overlayColor : '{$overlay}',
    stopOnHover: {$hover},
    rows: {$allrow},
    data: pcoldata});   
</script>
EOT;

    $htmlclose = $footblock."</body>";
    $html = str_replace("</body>", $htmlclose, $html);
}
    return $html;
}


?>